=== debian/changelog ===
astc-encoder (2.1+ds-3) unstable; urgency=medium

  * Fix keyword error in d/watch

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 07 Jan 2021 16:18:30 +0100

astc-encoder (2.1+ds-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 25 Dec 2020 16:54:45 +0100

astc-encoder (2.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #977127)

 -- Timo Röhling <timo@gaussglocke.de>  Sun, 13 Dec 2020 20:26:48 +0100
