=== debian/control ===
Source: astc-encoder
Section: graphics
Priority: optional
Maintainer: Timo Röhling <timo@gaussglocke.de>
Build-Depends: debhelper-compat (= 13),
    cmake,
    libstb-dev,
    libtinyexr-dev
Homepage: https://github.com/ARM-software/astc-encoder
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder

Package: astcenc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ASTC image compression and decompression tool
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the command-line tool to compress and decompress
 images.

Package: libastcenc0d
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: ASTC image compression and decompression library
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the runtime library for ASTC support.

Package: libastcenc-dev
Section: libdevel
Architecture: any
Depends: libastcenc0d (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: ASTC image compression and decompression library headers
 The Adaptive Scalable Texture Compression (ASTC) format, developed by
 Arm® and AMD, has been adopted as an official extension to the Open GL®,
 OpenGL ES, and Vulkan® graphics APIs. It provides a major step forward
 both in terms of image quality at a given bitrate, and in terms of the
 format and bitrate flexibility available to content creators. This
 allows more assets to use compression, often at a reduced bitrate
 compared to legacy formats, reducing memory bandwidth and energy
 consumption.
 .
 This package provides the development headers to include ASTC support
 in other applications.
