=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

%:
	dh $@ --buildsystem=cmake

execute_before_dh_auto_configure:
	cp debian/extra/CMakeLists.txt .

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DCMAKE_SKIP_RPATH=ON
