## astc-encoder 3.3%2Bds

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0

SOVERSION := 1d
UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_SKIP_RPATH=ON \
		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
		-DASTCENC_SOVERSION=$(SOVERSION) \
		-DCMAKE_CXX_VISIBILITY_PRESET=hidden \
		-DUNITTEST=$(UNITTEST)
