=== debian/changelog ===
astc-encoder (3.3+ds-1) unstable; urgency=medium

  * New upstream version 3.3+ds
  * Refresh d/patches
  * Add Build-Depends-Package to .symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 10 Nov 2021 10:13:07 +0100

astc-encoder (3.2+ds-2) unstable; urgency=medium

  * Fix version number in library file name

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Aug 2021 23:07:38 +0200

astc-encoder (3.2+ds-1) unstable; urgency=medium

  * New upstream version 3.2+ds
  * Refresh d/patches
  * Add .symbols; ABI remained stable
  * Bump Standards-Version to 4.6.0

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Aug 2021 15:56:55 +0200

astc-encoder (3.1+ds-3) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Aug 2021 21:04:25 +0200

astc-encoder (3.1+ds-2) experimental; urgency=medium

  * Always disable Neon instruction set
  * Hide private symbols

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Aug 2021 20:04:41 +0200

astc-encoder (3.1+ds-1) experimental; urgency=medium

  * New upstream version 3.1+ds
  * Refresh d/patches
  * Bump version

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Aug 2021 16:08:40 +0200

astc-encoder (3.0+ds-2) experimental; urgency=medium

  * Link against pthread

 -- Timo Röhling <roehling@debian.org>  Sun, 13 Jun 2021 23:38:21 +0200

astc-encoder (3.0+ds-1) experimental; urgency=medium

  * New upstream version 3.0+ds
    - Fixes FTBFS with -march=x86-64-v2 (Closes: #983929)

 -- Timo Röhling <roehling@debian.org>  Fri, 04 Jun 2021 17:31:32 +0200

astc-encoder (2.5+ds-1) experimental; urgency=medium

  * New upstream version 2.5+ds
  * Bump to SOVERSION 1d
  * Update maintainer info
  * Switch to upstream CMake build system
  * Add autopkgtest

 -- Timo Röhling <roehling@debian.org>  Wed, 02 Jun 2021 22:57:43 +0200
