=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: astc-encoder
 Section: graphics
 Priority: optional
-Maintainer: Timo Röhling <timo@gaussglocke.de>
+Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13),
     cmake,
     libstb-dev,
-    libtinyexr-dev
+    libtinyexr-dev,
+    libz-dev,
+    pkg-config <!nocheck>, libgtest-dev <!nocheck>
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
@@ -28,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc0d
+Package: libastcenc1d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -48,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc0d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc1d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by
