=== debian/tests/control ===
Tests: build-and-run
Depends: libastcenc-dev, cmake, g++ | c++-compiler
Restrictions: allow-stderr
