=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1.tar.gz/,\
     dversionmangle=s/\+ds\d*$//,oversionmangle=s/$/+ds/,\
     repack \
https://github.com/ARM-software/astc-encoder/releases/latest .*/v?(\d\S+)\.tar\.gz
