## astc-encoder 4.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  SPDX-License-Identifier: Apache-2.0
 #  ----------------------------------------------------------------------------
-#  Copyright 2020-2021 Arm Limited
+#  Copyright 2020-2022 Arm Limited
 #
 #  Licensed under the Apache License, Version 2.0 (the "License"); you may not
 #  use this file except in compliance with the License. You may obtain a copy
@@ -24,13 +24,12 @@
     add_compile_options("/wd4324") # Disable structure was padded due to alignment specifier
 endif()
 
-project(astcencoder VERSION 3.3.0)
+project(astcencoder VERSION 4.1.0)
 
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
-set(PACKAGE_ROOT astcenc)
 
 include(CTest)
 
@@ -42,7 +41,9 @@
 option(ISA_NATIVE "Enable builds for native SIMD")
 option(DECOMPRESSOR "Enable builds for decompression only")
 option(DIAGNOSTICS "Enable builds for diagnostic trace")
+option(ASAN "Enable builds width address sanitizer")
 option(UNITTEST "Enable builds for unit tests")
+option(NO_INVARIANCE "Enable builds without invariance")
 option(CLI "Enable build of CLI" ON)
 
 set(UNIVERSAL_BUILD OFF)
@@ -183,12 +184,15 @@
 
 function(printopt optName optVal)
     if(${optVal})
-        message(STATUS "  ${optName} -  ON")
-    else()
-        message(STATUS "  ${optName} - OFF")
+        message(STATUS "  ${optName}  - ON")
+    else()
+        message(STATUS "  ${optName}  - OFF")
     endif()
 endfunction()
 
+if("${BLOCK_MAX_TEXELS}")
+     message(STATUS "  Max block texels - ${BLOCK_MAX_TEXELS}")
+endif()
 printopt("AVX2 backend   " ${ISA_AVX2})
 printopt("SSE4.1 backend " ${ISA_SSE41})
 printopt("SSE2 backend   " ${ISA_SSE2})
@@ -199,7 +203,9 @@
     printopt("Universal bin  " ${UNIVERSAL_BUILD})
 endif()
 printopt("Decompressor   " ${DECOMPRESSOR})
+printopt("No invariance  " ${NO_INVARIANCE})
 printopt("Diagnostics    " ${DIAGNOSTICS})
+printopt("ASAN           " ${ASAN})
 printopt("Unit tests     " ${UNITTEST})
 
 # Subcomponents
@@ -213,9 +219,7 @@
         string(TOLOWER ${CMAKE_SYSTEM_NAME} PKG_OS)
     endif()
 
-    set(PKG_VER ${CMAKE_PROJECT_VERSION_MAJOR}.${CMAKE_PROJECT_VERSION_MINOR})
-
-    set(CPACK_PACKAGE_FILE_NAME "astcenc-${PKG_VER}-${PKG_OS}-${PACKAGE}")
+    set(CPACK_PACKAGE_FILE_NAME "astcenc-${CMAKE_PROJECT_VERSION}-${PKG_OS}-${PACKAGE}")
     set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY FALSE)
     set(CPACK_PACKAGE_CHECKSUM SHA256)
     set(CPACK_GENERATOR ZIP)
