=== debian/changelog ===
astc-encoder (4.1.0+ds-1) unstable; urgency=medium

  * New upstream version 4.1.0+ds

 -- Timo Röhling <roehling@debian.org>  Sun, 21 Aug 2022 19:00:52 +0200

astc-encoder (4.0.0+ds-2) unstable; urgency=medium

  * Fix big endian unit test failure

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Jul 2022 21:47:41 +0200

astc-encoder (4.0.0+ds-1) unstable; urgency=medium

  * New upstream version 4.0.0+ds
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Jul 2022 00:57:02 +0200

astc-encoder (3.7+ds-1) unstable; urgency=medium

  * New upstream version 3.7+ds

 -- Timo Röhling <roehling@debian.org>  Fri, 29 Apr 2022 13:04:49 +0200

astc-encoder (3.6+ds-1) unstable; urgency=medium

  * New upstream version 3.6+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 11 Apr 2022 09:30:18 +0200

astc-encoder (3.5+ds-1) unstable; urgency=medium

  * New upstream version 3.5+ds

 -- Timo Röhling <roehling@debian.org>  Tue, 22 Mar 2022 09:38:32 +0100

astc-encoder (3.4+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 06 Mar 2022 10:54:36 +0100

astc-encoder (3.4+ds-1) experimental; urgency=medium

  * New upstream version 3.4+ds
  * Bump SONAME
    - libastcenc.so.1d -> libastcenc.so.2d

 -- Timo Röhling <roehling@debian.org>  Wed, 02 Mar 2022 12:03:01 +0100
