=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
 export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0
 
-SOVERSION := 1d
+SOVERSION := 2d
 UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:
