=== debian/changelog ===
astc-encoder (4.2.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 13 Nov 2022 09:06:41 +0100

astc-encoder (4.2.0+ds-1) experimental; urgency=medium

  * New upstream version 4.2.0+ds
  * Bump SONAME to 3d

 -- Timo Röhling <roehling@debian.org>  Fri, 11 Nov 2022 22:40:19 +0100

astc-encoder (4.1.0+ds-2) unstable; urgency=medium

  * Update d/watch
  * Do not embed libstb and tinyexr

 -- Timo Röhling <roehling@debian.org>  Sun, 02 Oct 2022 19:49:48 +0200
