=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc2d
+Package: libastcenc3d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -50,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc2d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc3d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by
