=== debian/changelog ===
astc-encoder (4.5.0+ds-2) unstable; urgency=medium

  * Fix linkage for astcenc CLI (Closes: #1039485)

 -- Timo Röhling <roehling@debian.org>  Mon, 26 Jun 2023 15:58:08 +0200

astc-encoder (4.5.0+ds-1) unstable; urgency=medium

  * New upstream version 4.5.0+ds
  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Thu, 22 Jun 2023 09:46:15 +0200

astc-encoder (4.4.0+ds-1) experimental; urgency=medium

  * New upstream version 4.4.0+ds
  * Bump Standards-Version to 4.6.2
  * Bump SONAME to 4d
  * Build and install static library as well

 -- Timo Röhling <roehling@debian.org>  Sat, 17 Jun 2023 21:44:35 +0200
