=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
     libz-dev,
     pkg-config <!nocheck>, libgtest-dev <!nocheck>
 Homepage: https://github.com/ARM-software/astc-encoder
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/astc-encoder.git
 Vcs-Browser: https://salsa.debian.org/roehling/astc-encoder
@@ -30,7 +30,7 @@
  This package provides the command-line tool to compress and decompress
  images.
 
-Package: libastcenc3d
+Package: libastcenc4d
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -50,7 +50,7 @@
 Package: libastcenc-dev
 Section: libdevel
 Architecture: any
-Depends: libastcenc3d (= ${binary:Version}), ${misc:Depends}
+Depends: libastcenc4d (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: ASTC image compression and decompression library headers
  The Adaptive Scalable Texture Compression (ASTC) format, developed by
