=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs
 export DEB_CXXFLAGS_MAINT_APPEND = -DASTCENC_NEON=0
 
-SOVERSION := 3d
+SOVERSION := 4d
 UNITTEST := $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:
@@ -17,5 +17,5 @@
 		-DCMAKE_SKIP_RPATH=ON \
 		-DASTCENC_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+ds.*//') \
 		-DASTCENC_SOVERSION=$(SOVERSION) \
-		-DCMAKE_CXX_VISIBILITY_PRESET=hidden \
-		-DUNITTEST=$(UNITTEST)
+		-DASTCENC_UNITTEST=$(UNITTEST) \
+		-DASTCENC_SHAREDLIB=ON
